/* One reason start to write and keep these variables were for Flex Scheduling.
Prior to using FLEX we typically could pull from STU joined with SEC, then MST and TCH to get the course information.
FLEX added some complexity to that in order to allow more flexibility in your course schedule.
Below is an example: */

DECLARE @StartYear as int = CAST(20-FLOOR(CAST(SUBSTRING(DB_NAME(),4,2) AS INT)/80) AS VARCHAR(2)) + CAST(SUBSTRING(DB_NAME(),4,2) AS VARCHAR(2))
DECLARE @AcademicYear VARCHAR(9) = (SELECT CAST(@StartYear AS VARCHAR(4)) + '-' + CAST(@StartYear + 1 AS VARCHAR(4)))
DECLARE @FilterDate DATETIME = CONVERT(date,GETDATE())

SELECT
	STU.SC 'SiteShortName',
	STU.ID 'Barcode',
	STU.ID 'DistrictID',
	STU.LN 'LastName',
	STU.FN 'FirstName',
	STU.MN 'MiddleName',
	'Student' 'PatronType',
	'Patron' 'AccessLevel',
	'A' 'Status',
	CASE
		WHEN STU.GN IN ('M', 'F') THEN STU.GN
		ELSE ''
	END 'Gender',
	(STF.FN + ' ' + STF.LN) 'Homeroom',
	STU.GR 'GradeLevel',
	CONVERT(VARCHAR(10), STU.BD, 101) 'BirthDate',
	STU.SEM 'username',
	'' 'Password'
FROM STU 
	INNER JOIN (SELECT * FROM SEC WHERE DEL = 0) SEC ON STU.SC = SEC.SC AND STU.SN = SEC.SN 
	INNER JOIN (SELECT * FROM MST WHERE DEL = 0 AND MST.SM IN (SELECT TRM.TM FROM TRM WHERE TRM.SC = MST.SC AND getdate() BETWEEN TRM.D1 AND TRM.D2)) MST ON SEC.SC = MST.SC AND SEC.SE = MST.SE
	INNER JOIN (SELECT * FROM SSE WHERE DEL = 0 AND SSE.PR = 1 AND 
	((SSE.SD IS NULL AND SSE.ED IS NULL) OR 
	(SSE.SD IS NULL AND SSE.ED <= @FilterDate) OR 
	(SSE.SD >= @FilterDate AND SSE.ED IS NULL)) OR
	(SSE.SD >= @FilterDate AND SSE.ED <= getdate())
	) SSE ON MST.SE = SSE.SE AND MST.SC = SSE.SC
	INNER JOIN (SELECT * FROM STF WHERE DEL = 0) STF ON SSE.ID = STF.ID 
	INNER JOIN (SELECT * FROM FTF WHERE DEL = 0 AND FTF.YR = @AcademicYear AND STI LIKE '%1%') FTF ON FTF.SQ = MST.FSQ AND FTF.SC = MST.SC 
WHERE STU.DEL = 0 AND STU.TG = '' AND STU.LN <> '_' AND STU.FN <> '_'  AND STU.SC IN (SELECT CD FROM LOC WHERE E = 3 AND DNR = 0) 
AND STU.SC = 894
