/* One of the things I don't think is necessarily and advanced feature is Date and TIME.
However, being able to get the date and being able to manipulate the date to ensure
that your code will work, and do what you want it to do.  So I just wanted to go 
over a few examples and details.  This is not a comprehensive guide, and is not
meant to be such.

EXTRACTING DATE and TIME */

SELECT getdate()

/* This returns a datetime value */
/* Let's look at the convert function in SQL Server
What is the CONVERT function in SQL Server?
CONVERT is a function in SQL Server that allows you to convert an expression 
from one data type to another. It can be used to extract the date from a datetime value.

CONVERT syntax:

CONVERT
 ( data_type [ ( length ) ] , expression [ , style ] )   */
SELECT CONVERT(date, getdate())
SELECT CONVERT(date, getdate()) as Date;
SELECT CONVERT(VARCHAR(10), getdate(), 111);

/* Some Common formats
Style	Display Format
101	mm/dd/yyyy
102	yyyy.mm.dd
103	dd/mm/yyyy
104	dd.mm.yyyy
105	dd-mm-yyyy
110	mm-dd-yyyy
111	yyyy/mm/dd
106	dd mon yyyy
107	Mon dd, yyyy
*/

/* What is CAST: What is the CAST function in SQL Server?
CAST is a function in SQL Server that allows you to change the data type of an expression. 
It can be used to extract time from the datetime function 
or convert datetime values to date-only formats. */

SELECT CAST(getdate() AS varchar(10));
SELECT CAST(getdate() AS time);


/* DATEDIFF DATEDIFF(interval, date1, date2)*/
/* Types of Intervals
interval	Required. The part to return. Can be one of the following values:
year, yyyy, yy = Year
quarter, qq, q = Quarter
month, mm, m = month
dayofyear = Day of the year
day, dy, y = Day
week, ww, wk = Week
weekday, dw, w = Weekday
hour, hh = hour
minute, mi, n = Minute
second, ss, s = Second
millisecond, ms = Millisecond */
SELECT DATEDIFF(year, '2017/08/25', '2011/08/25') AS DateDiff
SELECT STU.ID, DATEDIFF(year, STU.BD, getdate()) as DateDiff FROM STU

/* Notice I used getdate() several times. 
The GETDATE() function returns the current server time stamp using the datetime format. 
This function returns the same value as the CURRENT_TIMESTAMP function. 
GETDATE() is used mostly in SQL Server, but CURRENT_TIMESTAMP is the ANSI SQL standard. */
 
/* Examples of Current_TimeStamp */
SELECT CURRENT_TIMESTAMP as timestamp
SELECT DATEDIFF(SECOND, GETDATE(), CURRENT_TIMESTAMP) as difference --Getdate() vs CURRENT_TIMESTAMP
SELECT FORMAT(CURRENT_TIMESTAMP, 'dd-MM-yyyy hh:mm:ss tt') as formatdate --Change the format

/* DATENAME: The DATENAME function returns a string with the part specified in the function of the date used. */
--Simple Exampe of DATENAME
SELECT DATENAME(year, '2024-03-05 2:10:30.123') as datename
SELECT 
DATENAME(yy, '2024-03-05 2:10:30.123') as YEAR,
DATENAME(mm, '2024-03-05 2:10:30.123') as MONTH,
DATENAME(DD, '2024-03-05 2:10:30.123') as DAY,
DATENAME(hh, '2024-03-05 2:10:30.123') as HOUR,
DATENAME(mi, '2024-03-05 2:10:30.123') as MINUTE,
DATENAME(ss, '2024-03-05 2:10:30.123') as SECOND,
DATENAME(ms, '2024-03-05 2:10:30.123') as MILLISECOND

/*